/**
 * BSD-style license; for more info see http://pmd.sourceforge.net/license.html
 */
/* Generated By:JJTree: Do not edit this line. ASTNormalAnnotation.java */

package net.sourceforge.pmd.lang.java.ast;

/**
 * Represents an annotation that with a parenthesized list
 * of key-value pairs (possibly empty).
 *
 * <pre>
 *
 * NormalAnnotation ::=  "@" {@linkplain ASTName Name} "(" {@linkplain ASTMemberValuePairs MemberValuePairs}? ")"
 *
 * </pre>
 *
 * @see ASTSingleMemberAnnotation
 * @see ASTMarkerAnnotation
 */
public class ASTNormalAnnotation extends AbstractJavaTypeNode {
    public ASTNormalAnnotation(int id) {
        super(id);
    }


    public ASTNormalAnnotation(JavaParser p, int id) {
        super(p, id);
    }


    @Override
    public Object jjtAccept(JavaParserVisitor visitor, Object data) {
        return visitor.visit(this, data);
    }


    /**
     * Returns the name of the annotation as it is used,
     * eg {@code java.lang.Override} or {@code Override}.
     */
    public String getAnnotationName() {
        return jjtGetChild(0).getImage();
    }


    @Override
    public ASTAnnotation jjtGetParent() {
        return (ASTAnnotation) super.jjtGetParent();
    }
}
